/*
   Program....: Demo.Prg
   System.....: Demo.Prg
   Author.....: Michael Clerc
   Date.......: Fri  03-05-1993  14:10:57
   Purpose....: to demonstrate the versitility, and shear ease of use of both
              : Explode() and Implode(), and other Misc Functions from
              : MARVY50.Lib
              :
   Copyright..:           Simply Marvelous Solutions
                                 Mesa, AZ
                       (c) 1993 - All Rights Reserved
*/
Set ScoreBoard OFF
Set Confirm ON

Cursor(0)

Logo(3)            // my weird and wonderful logo.

SetColor("+w/b")
Explode(00,00,24,79,2,"+w/b","", 'aScreen')

nTop    := 1
nBottom := 5
nLeft   := 1
nRight  := ( nLeft + 13 )
nType   := 0
nCol    := 1
nSpeed  := 10
aColor  := {"+w/r", "+gr/w", "+bg/br", "+bg/b", "+b/bg"}

For nLoop = 0 to 19
  Explode(nTop, nLeft, nBottom, nRight, nSpeed, aColor[ nCol ], nType, ;
            "aBox" + Ltrim( Str( nLoop, 2 )))

  @nTop+1, nLeft+1 Say "  Type #" + Str(nType,2) + '  ' Color "n/w"
  @nTop+3, nLeft+1 Say "  Speed " + Str(nSpeed,3) + ' ' Color "+w/n"

  nTop    := nTop + 6
  nBottom := nBottom + 6

  If nBottom > 23
    nLeft   := nLeft + 16
    nRight  := nLeft + 13
    nTop    := 1
    nBottom := 5
    nCol++
  Endif

  nSpeed := nSpeed + 5
  nType++

  If nType = 12
    nType := 0
  Endif
Next

cBottline := SaveScreen(23,00,24,79)
SetColor('n/g')
Expand(" ***** Press any key to continue... ***** ",24)
Inkey(5)
RestScreen(23,00,24,79,cBottline)
Explode(02,07,22,73,10,"+gr/b",5,"aMainbox")
SetColor("+gr/w")
@03,08 Clear to 21,72
Cntr("                                                           ",2)
SetColor("+gr/r")
Cntr(" EXPLODING & IMPLODING Boxes by Simply Marvelous Solutions ",2)
SetColor("n/w")
Cntr(" To create these wonderful exploding and imploding box types   ",4)
Cntr(" in your Special Application, simply use the following syntax: ",5)
SetColor("r/w")
Cntr('Explode(nTop,nLeft,nBottom,nRight,nSpeed,cColor,nType,cName)',07)
SetColor("b/w")
Cntr("Where nTop   = top row        nBottom = bottom row         ",09)
Cntr("      nLeft  = left column    nRight  = right column       ",10)
Cntr('      nSpeed = speed          cColor  = color string       ',11)
Cntr('      nType  = box type       cName   = the box name       ',12)
SetColor("r/w")
Cntr('Implode(cName, nSpeed)',14)
SetColor("n/w")
Cntr("Where cName = the box name, nSpeed = Implosion speed        ",16)
SetColor("b/w")
Cntr("The box types are shown here on the screen.  The speed, should ",18)
Cntr("vary from 2 to ?, obviously the greater the number, the slower ",19)
Cntr("the explosion.  Note: speeds are affected by hardware...       ",20)
Explode(21,18,23,61,20,"+w/gr",9,"aWait")
SetColor('+gr/gr')
Cntr(" Press any key to IMPLODE these boxes.... ",22)
Inkey(0)
Implode("aWait",10)
Implode("aMainbox",15)
For nLoop = 20 to 1 Step -1
  Implode("aBox" + Ltrim( Str( (nLoop - 1), 2 )), 20)
Next
Special()
Extra()
AddLib2()
CursorDemo()
Inkey(.5)
Implode("aScreen",1)
Logo(1)
SetColor("+bg/n")
Clear
NanLogo(3,20)
@23,00 Say ""
Cursor(1)
Quit
** Eof........: Boxes.Prg

Procedure Special
*
* Program....: Special.Prg
* System.....: Demo.Prg
* Author.....: Michael Clerc
* Date.......: Fri  03-05-1993
* Purpose....: more samples of exploding and imploding boxes
*            :
*
Local nLoop
Cursor(0)
Explode(01,02,22,19,15,"+gr/gr",5,"_spec1")
Explode(04,12,14,72,20,"+gr/bg",0,"_spec2")
Explode(06,05,16,26,05,"n/g",6,"_spec3")
Explode(17,31,21,74,25,"+w/r",9,"_spec4")
Explode(05,17,23,35,25,"+gr/br",11,"_spec5")
Explode(01,45,22,65,10,"+br/w",1,"_spec6")
Explode(02,28,18,60,04,"+g/r",5,"_spec7")
Explode(03,15,17,76,30,"+bg/b",2,"_spec8")
Explode(00,53,23,72,20,"b/bg",3,"_spec9")
Explode(01,23,21,48,05,"+gr/n",5,"_spec10")
Explode(05,14,18,63,45,"+bg/br",5,"_spec11")
Editorial()
SetColor("+gr/n")
Expand(" Press any key to be further dazzled.....",17,50)
Inkey(0)
For nLoop = 11 to 1 Step -1
  Implode("_spec" + Ltrim( Str( nLoop, 2)), 15)
  Inkey(.20)
Next
Return
** Eof........: Special.Prg

Procedure Editorial
*
* Program....: Editorial.Prg
* System.....: Demo.Prg
* Author.....: Michael Clerc
* Date.......: Fri  03-05-1993
* Purpose....: a little editorial about the exploding and imploding boxes,
*            : with a dash of FREE Drama
*
SetColor("+bg/rb")
@07,18 Say "Isn't this nice?  Now you can have as many"
@08,18 Say "of these beautiful           boxes on the"
@09,18 Say "screen as you want, removing them in a way"
@10,18 Say "that is both                       , using"
@11,18 Say "         ."
@13,18 Say "Both of these functions are written in 99%"
@14,18 Say "        (c).  The only thing that is not in"
@15,18 Say "Clipper code are the transparent shadows."
SetColor("+gr/rb")
@08,37 Say "Exploding"
@10,31 Say "appealing"
SetColor("+g/br")
@10,41 Say "and "
SetColor("+w/br")
@10,45 SAY "dramatic"
SetColor("+g/br")
@11,18 SAY "Implode()"
SetColor("b/br")
@14,18 SAY "Clipper "
Return
** Eof........: Editorial.Prg

Procedure Extra
*
* Program....: Extra.Prg
* System.....: Demo.Prg
* Author.....: Michael Clerc
* Date.......: Fri  03-05-1993
* Purpose....: to show our viewers the other many splendored items available
*            : in the MARVY50.Lib
*
Local fname   := "Michael       ", lname   := "Clerc         ", ;
      cname   := "Simply Marvelous Solutions     ", ;
      address := "2330 N. Acacia                 ", ;
      city    := "Mesa                  ", state := "AX", zip := "85213", ;
      phone   := '6028902315', billing := "XX"

Cursor(0)
Explode(05,11,18,68,25,"+gr/br",7,"aSampscr")
@05,13 Say "                          " Color "+gr/br"
@05,14 SAY " Sample Data Entry Screen " Color "+gr/n"
SetColor("+bg/rb")
@07,14 Say "First Name:"
@08,15 Say "Last Name:"
@10,17 Say "Company:"
@11,17 Say "  Terms:"
@12,17 Say "Address:"
@13,20 Say "City:"
@14,19 Say "State:     Zip:"
@16,19 Say "Phone:"
SetColor("+w/rb,+gr/r,,,b/w")
AddLib()
@07,26 Get fname Picture "!xxxxxxxxxxxxx"
@08,26 Get lname Picture "!xxxxxxxxxxxxx"
@10,26 Get cname
@11,26 Get billing Picture "!!" Valid Termsok(billing)
@12,26 Get address
@13,26 Get city
@14,26 Get state Picture "!!" Valid IsState(state)
@14,35 Get zip Picture "99999"
@16,26 Get phone Picture "@r (999) 999-9999"
Keyboard Replicate(Chr(13),3)
Cursor(1)
Read

Cursor(0)
Clear Gets
Implode("aSampscr",30)
Inkey(.25)
Return
** Eof........: Extra.Prg

Procedure AddLib
*
* Program....: AddLib.Prg
* System.....: Demo.Prg
* Author.....: Michael Clerc
* Date.......: Fri  03-05-1993
* Purpose....: a preface to the Achoose(), IsState() functions
*            :
*
Cursor(0)
Explode(03,04,20,72,20,"+gr/w",6,"aAddlib")
SetColor("+gr/w")
@03,06 Say "                                         "
@20,18 Say "                                       "
SetColor("b/w")
@05,06 Say "I'm quite sure that on more than one occassion, you have had to"
@06,06 Say "deal with some really        data entry people.  In many cases,"
@07,06 Say "try as they will, some data entry people have difficulty in"
@08,06 Say "inputting the most simple of items such as the ever popular state"
@09,06 Say "abbreviation, or terms codes."
@11,06 Say "In one specific application, I had three such brain dead people."
@12,06 Say "So, in a noble ( ) effort to try and maintain some form of data"
@13,06 Say "integrity, I was able to come up with a method that was an aid"
@14,06 Say "in my battle against the ever raging war of invalid data entry."
@16,06 Say "In the example in the box behind this one, is an invalid state"
@17,06 Say "code, not unlike those experienced in the afore mentioned tale."
@18,06 Say "Watch what happens when you press [     ] on those entries....."
SetColor("+bg/br")
@03,07 Say " A Tale of Woe, with a Happy Ending..... "
SetColor("+gr/br")
@20,19 Say " Press any key to see the Ending...... "
SetColor("r/w")
@06,28 Say "stupid"
SetColor("+bg/w")
@12,22 Say "?"
@18,41 Say "Enter"
Inkey(0)
Implode("aAddlib",20)
** Eof........: AddLib.Prg

Procedure AddLib2
*
* Program....: AddLib2.Prg
* System.....: Demo.Prg
* Author.....: Michael Clerc
* Date.......: Fri  03-05-1993
* Purpose....: a final series of thoughts to explain some syntax of the
*            : Achoose() and IsState() functions
*
Cursor(0)
Explode(01,01,23,78,10,"+gr/w",5,"aLasthar")
SetColor("b/w")
@02,04 Say "As you can see, while NOT earth shattering, these little data validation"
@03,04 Say "routines do have their place.  The syntax is very simple, yet it offers"
@04,04 Say "a slick form normally not available in most applications.  See the"
@05,04 Say "accompanying Read.Me file for a complete explaination of the syntax"
@06,04 Say "requirements."
@08,04 Say "If you like the scroll box routine used in IsState(), it is also"
@09,04 Say "available in another form within the MARVY50.Lib, known as AChoose()."
@11,04 Say "As you may have guessed, it is an off-shoot of Achoice(), but with a"
@12,04 Say "little of the Marvelous flair.  Again, see the Read.Me file for a more"
@13,04 Say "in depth discussion."
@15,04 Say "Also included in this Lib, are functions such as Cursor(), Cntr() and"
@16,04 Say "Expand()."
@18,04 Say "If you like     of these functions, add a little spice to a lonely, hard"
@19,04 Say "working OLD programmers life, by leaving a message on CompuServ, my"
@20,04 Say "number is 72331,664, call me or maybe even drop me a line to offer that"
@21,04 Say "needed but seldom given and always appreciated encouragement"
@22,04 Say "(complaints?). That's NOT too steep of a price to ask...      IS IT?"
SetColor("+bg/w")
@18,16 Say "ANY "
Inkey(0)
Implode("aLasthar",15)
Return
** Eof........: AddLib2.Prg

*
* Program....: Termsok.Prg
* System.....: Demo.Prg
* Author.....: Michael Clerc
* Date.......: Fri  03-05-1993
* Purpose....: To verify the "terms data" entered - data validation
*
Function TermsOk( cTerm )
Local cOldcolor := SetColor(), nPtr, aRetval
Local aTermcode := {"A ", "B ", "C ", "D ", "E ", "F ", "G ", "H ", "BR", ;
                    "TP", "01", "02", "03", "04", "05", "06", "07", "08", ;
                    "09", "10", "11", "12", "99"}, ;
      aTermdesc := {"  A    Check With Order", "  B    Net 120 Days", ;
                    "  C    Sight Draft", "  D    No Charge", ;
                    "  E    2% - 10 Net 30 Days", "  F    Credit", ;
                    "  G    Net 90 Days", "  H    Net 60 Days", ;
                    "  BR   Branch Replenishment", "  TP   Term Payments", ;
                    "  01   Due on Reciept", "  02   Cash with Order", ;
                    "  03   ITT Financed Floor Plan", ;
                    "  04   Chrysler First Floor Plan", ;
                    "  05   Trans-America Financial", "  06   Net 30 Days", ;
                    "  07   Net 30 - 60 Days", "  08   Net 30 - 60 - 90 Days",;
                    "  09   C.O.D.", "  10   CTC Demo Program", ;
                    "  11   Aloha Lease Financing", ;
                    "  12   Chase Third Century Floor Plan", ;
                    "  99   In Legal Contact Credit Manager"}

nPtr = AScan(aTermcode,cTerm)

If nPtr > 0
  Cursor(1)
  Return(.T.)
Else
  Tone(50,3)
  cOldcolor := SetColor()
  nPtr      := Ascan(aTermcode,"01")
  nRetval   := AChoose(02,30,19,69,aTermdesc,nPtr,' Valid Terms & Descriptions ')
  SetColor(cOldcolor)
  If nRetval = 0
    Tone(50,3)
    Cursor(1)
    Return(.F.)
  Endif
  KeyBoard aTermcode[nRetval] + Chr(13)
  SetColor(cOldcolor)
  Cursor(1)
  Return(.F.)
Endif
** Eof........: TermsOK.Prg

/*
   Just a little demo of the Cursor() function...
*/
Function CursorDemo
Local aColor := {"n/bg", "+w/bg", "+r/bg", "+gr/bg", "+w/bg"}, nLoop
Cursor(0)
Explode(08,16,13,63,20,"+br/bg",10,"aCursor")
@9,19 Say "This is demonstrate the Cursor( [nState] )" Color "+w/bg"
@10,19 Say "Function..." Color "+w/bg"
@12,30 Say "This is Cursor(   )  " Color "+b/bg"
SetColor("n/bg")
@12,50 Say "   "
For nLoop = 0 to 4
  Cursor(nLoop)
  @12,46 Say LTrim(Str(nLoop)) Color aColor[nLoop + 1]
  @12,50 Say ""
  Inkey(2)
Next

Cursor(0)
Implode("aCursor",30)
** Eof........: CursorDemo.Prg
